/*
 * File: \project\schemas\todo.js                                              *
 */

const S = require("fluent-json-schema");

const todoSchema = S.object()
  .prop("title", S.string().required())
  .prop("description", S.string())
  .prop("time_created", S.string().format("date-time"))
  .prop("done", S.boolean())
  .prop("categories", S.array().items(S.string()))
  .prop("status_changed_at", S.string().format("date-time"));

module.exports = {
  GET_BY_ID: {
    params: S.object().prop("id", S.string().required()),
    response: {
      200: S.object().prop("message", S.string()).prop("value", todoSchema),
      404: S.object().prop("message", S.string()).prop("value", S.object()),
    },
  },

  GET_ALL: {
    response: {
      200: S.object()
        .prop("message", S.string())
        .prop("value", S.array().items(todoSchema)),
    },
  },

  POST: {
    body: todoSchema,
    response: {
      201: S.object().prop("message", S.string()).prop("value", S.string()),
      400: S.object().prop("message", S.string()).prop("value", S.object()),
    },
  },
};
